// Variables
$light: #fafafa;
$lightAccent: #ecf0f1;
$dark: #333333;
$primary: #db2b39;
$primaryAccent: #ff5b27;

$buttonPrimary: #0ee96a;
$buttonPrimaryAccent: #1eece0;

$buttonSecondary: $primaryAccent;
$buttonSecondaryAccent: #f5de0c;

// Base
html {
  font-family: "Montserrat", sans-serif;

  body {
    margin: 0 auto;

    * {
      font-weight: 600;
    }
  }
}

// Root
#root {
  display: flex;
  flex-direction: column;
  height: 100vh;
  width: 100vw;
}

// AppContainer
.app-container {
  display: flex;
  flex: 1;
  flex-direction: column;
  overflow: auto;
  padding: 1rem;
}

// HeaderBar
.header-bar {
  align-self: center;
  align-items: center;
  background: linear-gradient(97deg, $primary 0%, $primaryAccent 100%);
  border-radius: 2rem;
  color: $light;
  display: flex;
  flex: 0 0 40%;
  flex-direction: row;
  justify-content: space-between;
  padding: 0.1rem 1.6rem;
  position: absolute;
  width: 72vw;

  .limit-select {
    appearance: none;
    border: none;
    border-radius: 1rem;
    box-shadow: none;
    color: $dark;
    padding: 0.2rem 0.1rem 0.2rem 0.4rem;
  }
}

// NavigationBar
.navigation-bar {
  align-items: center;
  background: linear-gradient(97deg, $primary 0%, $primaryAccent 100%);
  border-radius: 1rem 1rem 0 0;
  bottom: 0;
  display: flex;
  justify-content: space-around;
  left: 0;
  min-height: 2vh;
  padding: 0.2rem 1rem;
  position: fixed;
  right: 0;

  .navigation-home {
    color: #ecf0f1;
    text-decoration: none;
  }
}

// Modal
.modal {
  background: rgba(51, 51, 51, 0.8);
  display: none;
  height: 100vh;
  width: 100vw;
  position: fixed;

  top: 0;
  left: 0;
  right: 0;
  bottom: 0;

  &.modal-active {
    align-items: center;
    display: flex;
    flex-direction: column;
    justify-content: center;
  }

  .modal-button {
    align-items: center;
    border: 0.2rem solid $primary;
    border-radius: 2rem;
    color: $lightAccent;
    display: flex;
    justify-content: center;
    padding: 0.4rem 0.8rem;

    &:hover {
      color: $light;
      cursor: pointer;
      background: $primary;
      border-color: $primary;
    }
  }

  .modal-container {
    align-items: center;
    background: linear-gradient(105deg, $light 0%, $lightAccent 100%);
    border-radius: 1rem;
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin: 0.8rem;
    max-height: 82vh;
    min-width: 56vw;
    padding: 0.8rem 1.2rem;
  }
}

// NicknameInput
.nickname-input {
  appearance: none;
  background-color: $light;
  border: 0.1rem solid darken($lightAccent, 10);
  border-radius: 1rem;
  box-shadow: none;
  margin: 0.3rem 0;
  padding: 0.4rem 1rem;
  width: 100%;

  &:focus {
    border-color: $buttonPrimary;
  }
}

// PokedexContainer
.pokedex-container {
  align-items: center;
  display: flex;
  flex: 1;
  flex-flow: wrap;
  justify-content: center;
  padding-top: 4rem;

  // PokedexCard
  .pokedex-card {
    align-items: center;
    background: linear-gradient(105deg, $light 0%, $lightAccent 100%);
    border-radius: 1rem;
    box-shadow: 0px 8px 8px $lightAccent;
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin: 0.6rem;
    min-width: 30vh;
    min-height: 30vh;
    padding: 0.6rem 1.4rem;

    .pokedex-card-title {
      color: $dark;
      text-transform: uppercase;
    }

    &:hover,
    &:focus {
      box-shadow: 0px 2px 8px $lightAccent;
      cursor: pointer;
    }
  }
}

// PokedexDetail && PokemonCard
.pokemon-detail,
.pokemon-card {
  align-items: center;
  display: flex;
  flex-direction: column;
  height: 100%;
  justify-content: center;
  min-width: 72vw;
  overflow: auto;

  .pokemon-title {
    margin-top: 1rem;
  }
}

// PokemonStats & PokemonTypes
.pokemon-stats,
.pokemon-types {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;

  .type-badge {
    color: $dark;
    background: darken($color: $lightAccent, $amount: 15);
    border-radius: 2rem;
    padding: 0.4rem 1rem;
    margin: 0.2rem;
  }

  .stats-badge {
    align-items: center;
    border: 2px solid darken($color: $lightAccent, $amount: 15);
    border-radius: 2rem;
    color: $dark;
    display: flex;
    flex-direction: row;
    height: 2rem;
    justify-content: center;
    padding-left: 1rem;
    margin: 0.2rem;

    .stats-number {
      align-items: center;
      background: darken($color: $lightAccent, $amount: 15);
      border-radius: 0 2rem 2rem 0;
      color: $dark;
      display: flex;
      justify-content: center;
      height: 2rem;
      margin-left: 0.5rem;
      min-width: 2.4rem;
    }
  }
}

// MyPokemon
.mypokemon-container {
  align-items: flex-start;
  display: flex;
  flex: 1;
  flex-flow: wrap;
  justify-content: center;
  padding-top: 4rem;

  //MyPokemonCard
  .mypokemon-card {
    align-items: center;
    background: linear-gradient(105deg, $light 0%, $lightAccent 100%);
    box-shadow: 0px 8px 8px $lightAccent;
    border-radius: 1rem;
    display: flex;
    flex-direction: column;
    justify-content: space-around;
    margin: 0.6rem;
    min-height: 30vh;
    min-width: 30vh;
    padding: 0.6rem 1.4rem;

    .mypokemon-header {
      align-items: center;
      display: flex;
      flex-direction: column;
      height: 15vh;
      justify-content: center;
    }

    .mypokemon-content {
      align-items: center;
      display: flex;
      flex-direction: column;
      height: 10vh;
      justify-content: flex-end;

      .mypokemon-nickname {
        margin: 0.4rem;
        padding: 0.4rem 0.8rem;
      }
    }
  }
}

// Nickname Container
.pokemon-nickname {
  align-items: center;
  display: flex;
  flex-direction: row;
  justify-content: center;
  width: 100%;

  .nickname-close {
    align-items: center;
    color: $primaryAccent;
    background: none;
    border: none;
    border-radius: 2rem;
    display: flex;
    font-size: 1rem;
    height: 2rem;
    justify-content: center;
    width: 2rem;

    &:hover,
    &:focus {
      color: $dark;
    }
  }
}

// Buttons
.primary-button {
  background: linear-gradient(
    105deg,
    $buttonPrimary 0%,
    $buttonPrimaryAccent 100%
  );
  border: none;
  border-radius: 1rem;
  box-shadow: none;
  color: $light;
  margin: 0.4rem;
  padding: 0.4rem 0.8rem;
  text-align: center;
  width: 100%;

  &:hover,
  &:focus {
    box-shadow: 0px 2px 8px rgba($buttonPrimary, 0.33);
    cursor: pointer;
  }
}

.secondary-button {
  background: linear-gradient(
    105deg,
    $buttonSecondary 0%,
    $buttonSecondaryAccent 100%
  );
  border: none;
  border-radius: 1rem;
  color: $light;
  box-shadow: none;
  margin: 0.4rem;
  padding: 0.4rem 0.8rem;
  text-align: center;
  width: 100%;

  &:hover,
  &:focus {
    box-shadow: 0px 2px 8px rgba($buttonSecondary, 0.33);
    cursor: pointer;
  }
}

.nickname-button {
  background: linear-gradient(105deg, $dark 0%, darken($lightAccent, 5) 100%);
  border: none;
  border-radius: 1rem;
  box-shadow: none;
  color: $light;
  margin: 0.4rem;
  padding: 0.4rem 0.8rem;
  text-align: center;
  width: 100%;

  &:hover,
  &:focus {
    box-shadow: 0px 2px 8px rgba($dark, 0.33);
    cursor: pointer;
  }
}
